unit MyFrame;

{$mode ObjFPC}{$H+}

interface

uses
  Classes, SysUtils, SQLDB, DB, Forms, Controls, StdCtrls, Dialogs, DBCtrls,
  ExtCtrls;

type

  TMyInfoEvent = procedure(Sender: TObject; Info:string) of object;

  { TMyFrame }

  TMyFrame = class(TFrame)
    Button1:  TButton;
    Button2: TButton;
    Label1: TLabel;
    Memo1:    TMemo;
    Panel1: TPanel;
    procedure Button1Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
  private
    FOnInfo:  TMyInfoEvent;
    procedure DoInfo(Sender: TObject; Info: string);
  public
    procedure comptest;
    procedure MyRefresh;virtual;
    //procedure MyRefresh(Sender: TObject; WhichFrame: string);
  published
    property OnInfo: TMyInfoEvent read FOnInfo write FOnInfo;
    property OnRefreshInfo: TMyInfoEvent read FOnInfo write FOnInfo;
    procedure RefreshAnyFrame(FrameNameToRefresh:string);

  end;

implementation

{$R *.lfm}


{ TMyFrame }
procedure TMyFrame.Button1Click(Sender: TObject);
begin
  DoInfo(Sender, Memo1.Text);
end;

{Dieser Button soll ein bestimmtes Frame (aktualisieren das grundsätzlich
irgendwo in der Applikation sein kann. zB nachdem irgend etwas verändert
wurde das dieses bestimmte Frame beeinflusst}
procedure TMyFrame.Button2Click(Sender: TObject);
var
  c:TComponent;
  sSearchName:string;
begin
  {hier wird als Demo nur das jeweils andere Frame gesucht
   es könnte ein beliebiges Frame mit gleichem Vorfahren sein dessen Name bekannt ist}
  if self.Name='Frame1' then sSearchName:='Frame2' else sSearchName:='Frame1';
  RefreshAnyFrame(sSearchName);
end;

procedure TMyFrame.DoInfo(Sender:TObject; Info:string);
begin
  if Assigned(FOnInfo) then
    FOnInfo(Sender, Info);
end;

procedure TMyFrame.comptest;
begin
  showmessage('Heureka '+self.Name+' Frame gefunden');
end;

procedure TMyFrame.MyRefresh;
begin
  //hier könnten Anweisungen zum Refreshen des Frames stehen die für alle abgeleiteten Nachkommen gelten
  //Individuelle Refresh-Anweisungen werden im Nachkommen geregelt
end;

{Das Frame kennt seinen Owner. Es werden alle anderen Frames die den gleichen
 Owner haben über ihren Namen gefunden}
procedure TMyFrame.RefreshAnyFrame(FrameNameToRefresh: string);
var
  c:TComponent;
begin
  c:=self.Owner.FindComponent(FrameNameToRefresh);
  if (c is TMyFrame) then
     TMyFrame(c).MyRefresh
  else
    ShowMessage('Oops - falsche Komponente erwischt. Irgendwas ist faul im Frame');
end;

end.

