unit Unit1;

{$mode objfpc}{$H+}

interface

uses
  Classes, SysUtils, Forms, Controls, Graphics, Dialogs, ComCtrls, StdCtrls,
  ExtCtrls, MyFrame, MyFrameClientA,MyFrameClientB;

type

  { TForm1 }

  TForm1 = class(TForm)
    Button1: TButton;
    ComboBox1: TComboBox;
    ComboBox2: TComboBox;
    ComboBox3: TComboBox;
    PageControl1: TPageControl;
    Panel1: TPanel;
    Panel2: TPanel;
    Panel3: TPanel;
    Panel4: TPanel;
    Panel5: TPanel;
    TabSheet1: TTabSheet;
    TabSheet2: TTabSheet;
    procedure Button1Click(Sender: TObject);
    procedure FormCreate(Sender: TObject);
  private
    MyFrame1: TMyFrame;
    MyFrame2: TMyFrame;
    //MyTmpA, MyTmpB: string;
    procedure ShowValuesA(Sender: TObject; Info:string);
    procedure ShowValuesB(Sender: TObject; Info:string);
  public

  end;

var
  Form1: TForm1;

implementation

{$R *.lfm}

{ TForm1 }
procedure TForm1.FormCreate(Sender: TObject);
begin
  if (not assigned(MyFrame1)) then
  begin
    {für die spätere Suche nach Frames ist es entscheidend dass sie an einer
     Stelle zusammengefasst sind, das ist in diesem Fall das Formular.
     Deswegen werden die Frames mit dem Owner self erstellt}
    MyFrame1 := TMyFrameClientA.Create(self);
    MyFrame1.Name:='Frame1';
    MyFrame1.Label1.Caption:='Framename: Frame1';
    MyFrame1.Parent := Panel1;
    MyFrame1.Align := alClient;
    MyFrame1.OnInfo := @ShowValuesA;
  end;
  if (not assigned(MyFrame2)) then
  begin
    MyFrame2 := TMyFrameClientB.Create(self);
    MyFrame2.Name:='Frame2';
    MyFrame2.Label1.Caption:='Framename Frame2';
    MyFrame2.Parent := Panel2;
    MyFrame2.Align := alClient;
    MyFrame2.OnInfo := @ShowValuesB;
  end;
end;

{ Suche nach einem bestimmten Frame vom übergeordneten Formular aus.}
procedure TForm1.Button1Click(Sender: TObject);
var
  c:TComponent;
begin
  c:=FindComponent('Frame2');
  if (c is TMyFrame) then
     TMyFrame(c).comptest
  else
    ShowMessage('Oops - falsche Komponente erwischt. Irgendwas ist faul...');
end;

procedure TForm1.ShowValuesA(Sender: TObject; Info: string);
begin
  MyFrame1.Memo1.Text := 'Text1: ' + ComboBox1.Text + ' und Text2: ' + ComboBox2.Text;
end;

procedure TForm1.ShowValuesB(Sender: TObject; Info: string);
begin
  MyFrame2.Memo1.Text := 'Text3: ' + ComboBox3.Text;
end;


end.

